    001/* ===========================================================
    002 * Orson Charts : a 3D chart library for the Java(tm) platform
    003 * ===========================================================
    004 *
    005 * (C)opyright 2013-2022, by David Gilbert.  All rights reserved.
    006 *
    007 * https://github.com/jfree/orson-charts
    008 *
    009 * This program is free software: you can redistribute it and/or modify
    010 * it under the terms of the GNU General Public License as published by
    011 * the Free Software Foundation, either version 3 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This program is distributed in the hope that it will be useful,
    015 * but WITHOUT ANY WARRANTY; without even the implied warranty of
    016 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    017 * GNU General Public License for more details.
    018 *
    019 * You should have received a copy of the GNU General Public License
    020 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
    021 *
    022 * [Oracle and Java are registered trademarks of Oracle and/or its affiliates.
    023 * Other names may be trademarks of their respective owners.]
    024 *
    025 * If you do not wish to be bound by the terms of the GPL, an alternative
    026 * commercial license can be purchased.  For details, please see visit the
    027 * Orson Charts home page:
    028 *
    029 * http://www.object-refinery.com/orsoncharts/index.html
    030 *
    031 */
    032
    033package org.jfree.chart3d.data.function;
    034
    035import java.io.Serializable;
    036import org.jfree.chart3d.data.Range;
    037import org.jfree.chart3d.data.xyz.XYZDatasetUtils;
    038
    039/**
    040 * Represents a function {@code y = f(x, z)}.
    041 * <br><br>
    042 * A dataset can be created by sampling a function - see the
    043 * {@link XYZDatasetUtils#sampleFunction(Function3D, String, Range, double, Range, double)}
    044 * method.  In addition, any {@code Function3D} instance can be plotted
    045 * by a {@link org.jfree.chart3d.renderer.xyz.SurfaceRenderer}.
    046 */
    047public interface Function3D extends Serializable {
    048
    049    /**
    050     * Returns the value of the function ('y') for the specified inputs ('x'
    051     * and 'z').
    052     *
    053     * @param x  the x-value.
    054     * @param z  the z-value.
    055     *
    056     * @return The function value.
    057     */
    058    double getValue(double x, double z);
    059
    060}